#import "VolumeControlPlugin.h"
#import "MediaPlayer/MPVolumeView.h"
//AVFoundation.AVFAudio.AVAudioSession
#import <AVFoundation/AVFoundation.h>

@implementation VolumeControlPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"volume_control"
            binaryMessenger:[registrar messenger]];
  VolumeControlPlugin* instance = [[VolumeControlPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}


UISlider* volumeViewSlider = nil;
MPVolumeView* volumeView = nil;

- (void)dispose{
    if (volumeViewSlider!=nil){
        [volumeViewSlider removeFromSuperview];
        volumeViewSlider = nil;
    }
    
    if (volumeView!=nil){
        [volumeView removeFromSuperview];
        volumeView = nil;
    }
}

- (void)initVolume{
    /*
     * 这句注释掉，会导致每次调用都初始化，也就是往 window里插入多少个 MPVolumeView，
     * 但就导致调音量无效，可能第一次调用不算，第二次才算，而第二次时，又
     * 再重新插入新的 MPVolumeView，暂时怀疑这个
     *
     */
    if (volumeViewSlider!=nil)return;

    
    NSLog(@"INIT...");
    
    UIWindow* window = [UIApplication sharedApplication].keyWindow;
    if (!window) {
        window = [[UIApplication sharedApplication].windows objectAtIndex:0];
    }
    
    

    //CGRect frame = CGRectZero;
    //frame.origin.y = 0;
    //frame.origin.x = 410;
    
    volumeView = [[MPVolumeView alloc] initWithFrame:CGRectMake(-100, -100, 10, 10)];
    //[volumeView setShowsVolumeSlider:NO];
    //[volumeView setShowsRouteButton:YES];
    //[volumeView setHidden:YES];
    volumeView.hidden = YES;
    volumeView.alpha = 0.0001;
    
    for(UIView *view in [volumeView subviews]){

      if([view.class.description isEqualToString:@"MPVolumeSlider"]){
          NSLog(@"found slider");
          volumeViewSlider = (UISlider*)view;
          break;
      }
    }
    volumeViewSlider.alpha = 0.01;
    volumeViewSlider.hidden = YES;
    volumeViewSlider.userInteractionEnabled = NO;
    
    //[volumeViewSlider setMinimumTrackImage:[UIImage alloc] forState:UIControlStateNormal];
    //[volumeViewSlider setMaximumTrackImage:[UIImage alloc] forState:UIControlStateNormal];
    //[volumeViewSlider setMinimumTrackTintColor:[UIColor clearColor]];
    //[volumeViewSlider setMaximumTrackTintColor:[UIColor clearColor]];
    
    [window addSubview:volumeView];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  NSLog(@"method call");

  if ([@"dispose" isEqualToString:call.method]) {
      [self dispose];
      NSLog(@"VolumeControlPlugin dispose");

  }else if ([@"setVolume" isEqualToString:call.method]) {

      NSNumber *vol = call.arguments[@"vol"];
      float _vol = vol.floatValue;
      [self initVolume];
      if (_vol>1)_vol=1;
      if (_vol<0)_vol=0;
      
      volumeViewSlider.value = _vol;
      //[volumeViewSlider sendActionsForControlEvents:UIControlEventTouchUpInside];
       NSLog(@"setting vol:%f",_vol);

      
  }else if ([@"getVolume" isEqualToString:call.method]) {
      [self initVolume];
      
      /*
      AVAudioSession *audioSession = [AVAudioSession sharedInstance];
      audioSession.outputVolume
    */
       
      NSLog(@"val:%f",volumeViewSlider.value);
      result([NSNumber numberWithFloat:volumeViewSlider.value]);
      

  } else {
    result(FlutterMethodNotImplemented);
  }
}


@end
