import 'dart:async';

import 'package:flutter/services.dart';

class VolumeControl {
  static const MethodChannel _channel =
      const MethodChannel('volume_control');

  static bool _init = false;
  static void init(){
    if (_init)return;
    _init = true;
    //print("init VolumeControl");
    _channel.invokeMethod('init');
  }

  static setVolume(double vol) async {
    _channel.invokeMethod('setVolume',{"vol":vol});
  }


  static dispose() {
    _channel.invokeMethod('dispose');
  }

  static Future<double> get volume async {
    final double vol = await _channel.invokeMethod('getVolume');
    return vol;
  }

}
